;-------------------------------------------------------------------------------
;       Einbinden der controllerspezifischen Definitionsdatei
;-------------------------------------------------------------------------------
.NOLIST                         ;List-Output ausschalten
.INCLUDE "m32def.inc"           ;AVR-Definitionsdatei einbinden
.INCLUDE "reszif.asm"           ;Resevierung Ziffernanzeige
.INCLUDE "MeineMacros.inc"      ;Meine Macros
.INCLUDE "AVRMacros.inc"        ;AVR Macros mit einer nderung von mir 
;                               ;addi funktionierte nicht richtig
.LIST                           ;List-Output wieder einschalten

;*******************************************************************************
; alle Parameter von 000 - 899 stehen zur freien Verfgung
;*******************************************************************************
.equ uhrzeit     = var001      ; 001 Uhrzeit in Sunden * 100 + Minuten Format HHMM       
.equ k1_ein      = var011      ; 011 Einschaltzeit Kanal 1 HHMM
.equ k2_ein      = var012      ; 012 Einschaltzeit Kanal 2 HHMM
.equ k3_ein      = var013      ; 013 Einschaltzeit Kanal 3 HHMM
.equ k4_ein      = var014      ; 014 Einschaltzeit Kanal 4 HHMM
.equ k5_ein      = var015      ; 015 Einschaltzeit Kanal 5 HHMM
.equ k6_ein      = var016      ; 016 Einschaltzeit Kanal 6 HHMM
.equ k7_ein      = var017      ; 017 Nachlaufzeit in Sekunden Kanal 7 wenn Taster 1 gedrckt wurde
.equ k8_ein      = var018      ; 018 Nachlaufzeit in Sekunden Kanal 8 wenn Taster 2 gedrckt wurde

.equ k1_aus      = var021      ; 021 Ausschaltzeit Kanal 1 HHMM
.equ k2_aus      = var022      ; 022 Ausschaltzeit Kanal 2 HHMM
.equ k3_aus      = var023      ; 023 Ausschaltzeit Kanal 3 HHMM
.equ k4_aus      = var024      ; 024 Ausschaltzeit Kanal 4 HHMM
.equ k5_aus      = var025      ; 025 Ausschaltzeit Kanal 5 HHMM
.equ k6_aus      = var026      ; 026 Ausschaltzeit Kanal 6 HHMM


.equ fu10c       = var070      ; 070 Funktionsschritt Schaltuhr              
.equ fu20c       = var072      ; 072 Funktionsschritt LCD-Display            
.equ fu30c       = var074      ; 074 Funktionsschritt LCD-Anzeige vorbereiten
;
.equ stelle1_01  = var701      ; 701 1. Stelle auf dem Display
.equ stelle1_02  = var702      ; 701 1. Stelle auf dem Display
.equ stelle1_03  = var703      ; 701 1. Stelle auf dem Display
.equ stelle1_04  = var704      ; 701 1. Stelle auf dem Display
.equ stelle1_05  = var705      ; 701 1. Stelle auf dem Display
.equ stelle1_06  = var706      ; 701 1. Stelle auf dem Display
.equ stelle1_07  = var707      ; 701 1. Stelle auf dem Display
.equ stelle1_08  = var708      ; 701 1. Stelle auf dem Display
.equ stelle1_09  = var709      ; 701 1. Stelle auf dem Display
.equ stelle1_10  = var710      ; 701 1. Stelle auf dem Display
.equ stelle1_11  = var711      ; 701 1. Stelle auf dem Display
.equ stelle1_12  = var712      ; 701 1. Stelle auf dem Display
.equ stelle1_13  = var713      ; 701 1. Stelle auf dem Display
.equ stelle1_14  = var714      ; 701 1. Stelle auf dem Display
.equ stelle1_15  = var715      ; 701 1. Stelle auf dem Display
.equ stelle1_16  = var716      ; 701 1. Stelle auf dem Display
.equ stelle2_01  = var721      ; 701 1. Stelle auf dem Display
.equ stelle2_02  = var722      ; 701 1. Stelle auf dem Display
.equ stelle2_03  = var723      ; 701 1. Stelle auf dem Display
.equ stelle2_04  = var724      ; 701 1. Stelle auf dem Display
.equ stelle2_05  = var725      ; 701 1. Stelle auf dem Display
.equ stelle2_06  = var726      ; 701 1. Stelle auf dem Display
.equ stelle2_07  = var727      ; 701 1. Stelle auf dem Display
.equ stelle2_08  = var728      ; 701 1. Stelle auf dem Display
.equ stelle2_09  = var729      ; 701 1. Stelle auf dem Display
.equ stelle2_10  = var730      ; 701 1. Stelle auf dem Display
.equ stelle2_11  = var731      ; 701 1. Stelle auf dem Display
.equ stelle2_12  = var732      ; 701 1. Stelle auf dem Display
.equ stelle2_13  = var733      ; 701 1. Stelle auf dem Display
.equ stelle2_14  = var734      ; 701 1. Stelle auf dem Display
.equ stelle2_15  = var735      ; 701 1. Stelle auf dem Display
.equ stelle2_16  = var736      ; 701 1. Stelle auf dem Display





.equ merker1     = var801      ; 801 Merker um Led 1 zu schalten 1 Byte reicht
.equ merker2     = var801+1    ; 801+1 Merker um Led 2 zu schalten 1 Byte reicht
.equ merker3     = var802      ; 802 Merker um Hupe zu schalten 1 Byte reicht

.equ sr_sec1     = var803      ; 803 Sekundenzaehler 1 wird zu null gezhlt
.equ sr_sec2     = var804      ; 804 Sekundenzaehler 2 wird zu null gezhlt
.equ sr_v20f     = var805      ; 805 Verzgerung fr LCD
.equ sr_v30f     = var806      ; 806 Verzgerung fr LCD-Anzeige Vorbereiten
.equ bcd1 = var807
.equ bcd2 = var807+1
.equ bcd3 = var808
.equ bcd4 = var808+1
.equ bcd5 = var809




.equ Led1 = 0x20               ; Bit Led 1
.equ Led2 = 0x40               ; Bit Led 2
.equ Hupe = 0x80               ; Bit Hupe
.equ Taster1 = 0x04            ; Bit Taster 1
.equ Taster2 = 0x08            ; Bit Taster 2
.equ Taster3 = 0x10            ; Bit Taster 3


;*******************************************************************************
; alle Parameter von 900 - 999 sind vom System belegt
;*******************************************************************************
;
; sr_inp_portx wird am Anfang eines jedes Zyklus vom Eingangsport eingelesen
; und nur hier
.equ sr_inp_porta = var901   ; 901 Eingangsbyte Port A
.equ sr_inp_portb = var902   ; 902 Eingangsbyte Port B
.equ sr_inp_portc = var903   ; 903 Eingangsbyte Port C
.equ sr_inp_portd = var904   ; 904 Eingangsbyte Port D
;
; sr_oup_portx wird am Ende jedes Zyklus an das Ausgangsport weitergegeben
; und nur hier
.equ sr_oup_porta = var905   ; 905 Ausgangsbyte Port A
.equ sr_oup_portb = var906   ; 906 Ausgangsbyte Port B
.equ sr_oup_portc = var907   ; 907 Ausgangsbyte Port C
.equ sr_oup_portd = var908   ; 908 Eingangsbyte Port D

.equ sr_hsec      = var911   ; 911 Hundertstel Sekunde
.equ sr_sec       = var912   ; 912 Sekunde
.equ sr_min       = var913   ; 913 Minute 
.equ sr_std       = var914   ; 914 Stunde
.equ sr_tag       = var915   ; 915 Tag    
.equ sr_mon       = var916   ; 916 Monat  
.equ sr_jahr      = var915   ; 917 Jahr
;
;                            ; 921 SRAM-Daten von 000-499 
;                            ;     und Datum und Uhrzeit
;                            ;     1 = im EEPROM ablegen
;                            ;     2 = aus EEPROM lesen
;                            ;  1001 = alle Werte von 000-499 auf 0 setzen
;                            ;  1002 = alle Werte von 500-899 auf 0 setzen
;
;                            ; 935 Programmzyklen pro Sekunde
;
;*******************************************************************************
	
	
;===============================================================================
.CSEG                                                                            
.ORG    0x1000                  
user_init:    
 nop
jmp initialisieren
;===============================================================================
.CSEG                                                                            
.ORG    0x1004                  
jede_hsekunde:
 nop
jmp alle_10ms
;===============================================================================
.CSEG                                                                            
.ORG    0x1008                  
jede_zsekunde:
 nop
jmp alle_100ms
;===============================================================================
.ORG    0x100c                  
jede_sekunde:
 nop
jmp alle_1000ms
;===============================================================================
.ORG    0x1010                  
jeder_zyklus:
 nop
jmp alle_zyklen
;===============================================================================
.ORG    0x1020                  
; 1.Zeile Text auf dem Bildschirm
; Anlagenname als Text
Anlagenname1:
   .DB 27,"[1;12H",27,"#3Test-TC1602E-01@"
.ORG    0x1060                  
; 2.Zeile Text auf dem Bildschirm
; Anlagenname als Text
Anlagenname2:
   .DB 27,"[2;12H",27,"#4Test-TC1602E-01@"
;
.ORG    0x1100                  
;
;*******************************************************************************
; was hier steht wird nach jedem Neustart ausgefhrt
;*******************************************************************************
;
initialisieren:
;
; hier knnen die Ports A-C neu initialisiert werden.
; Bitte Port D nicht ndern.
; z.B.
         ldi r16, 0xff
         out DDRA, r16     ; Alle Pins am Port A durch Ausgabe von 0xFF ins
                           ; Richtungsregister DDRA als Ausgang konfigurieren
         ldi r16, 0x00
         out DDRB, r16     ; Alle Pins am Port B durch Ausgabe von 0x00 ins
                           ; Richtungsregister DDRB als Eingang konfigurieren
         ldi r16, 0x07
         out DDRC, r16     ; Alle Pin1-3 am Port C durch Ausgabe von 0x07 ins
                           ; Richtungsregister DDRC als Ausgang konfigurieren
                           ; Alle anderen Pins als Eingang konfigurieren
;                          ;    A c h t u n g !
;                          ; Fuse Bit JTAGEN Hckchen aus damit PortC Bit 2
;                          ; als Ausgang genutzt werden kann. 
;
         smemw fu20c,0     ; Funktionsschritt auf 0 setzen
         smemw fu30c,0     ; Funktionsschritt auf 0 setzen
;
;
; Pufferspeicher fr LCD 
;
;
         ldi r16,'B'                                         
         sts stelle1_01,r16
         ldi r16,'e'                                                        
         sts stelle1_02,r16
         ldi r16,'i'                                         
         sts stelle1_03,r16
         ldi r16,'s'                                         
         sts stelle1_04,r16
         ldi r16,'p'                                         
         sts stelle1_05,r16
         ldi r16,'i'                                         
         sts stelle1_06,r16
         ldi r16,'e'                                         
         sts stelle1_07,r16
         ldi r16,'l'                                         
         sts stelle1_08,r16
         ldi r16,' '                                         
         sts stelle1_09,r16
         ldi r16,'L'                                         
         sts stelle1_10,r16
         ldi r16,'C'                                         
         sts stelle1_11,r16
         ldi r16,'D'                                         
         sts stelle1_12,r16
         ldi r16,'-'                                         
         sts stelle1_13,r16
         ldi r16,'A'                                         
         sts stelle1_14,r16
         ldi r16,'n'                                         
         sts stelle1_15,r16
         ldi r16,'z'                                         
         sts stelle1_16,r16
         ldi r16,'T'                                         
         sts stelle2_01,r16
         ldi r16,'C'                                         
         sts stelle2_02,r16
         ldi r16,'1'                                         
         sts stelle2_03,r16
         ldi r16,'6'                                         
         sts stelle2_04,r16
         ldi r16,'0'                                         
         sts stelle2_05,r16
         ldi r16,'2'                                         
         sts stelle2_06,r16
         ldi r16,'E'                                         
         sts stelle2_07,r16
         smemw stelle2_08,32
         smemw stelle2_09,32
         smemw stelle2_10,32
         smemw stelle2_11,32
         smemw stelle2_12,32
         smemw stelle2_13,32
         smemw stelle2_14,32
         smemw stelle2_15,32
         smemw stelle2_15,32
 ret
;
;*******************************************************************************
; was hier steht wird alle 10ms ausgefhrt
;*******************************************************************************
;
alle_10ms:
 ret
;
;*******************************************************************************
; was hier steht wird alle 100ms ausgefhrt
;*******************************************************************************
;
alle_100ms:
 call Led1_toggeln
 ret
;
;*******************************************************************************
; was hier steht wird alle 1000ms ausgefhrt
;*******************************************************************************
;
alle_1000ms:
 call Led2_toggeln
 call sec_dec
 ret
;
;*******************************************************************************
; was hier steht was so den Rest der Zeit ausgefhrt werden soll
; das heit alle Interrupts sind abgearbeitet
;*******************************************************************************
;
alle_zyklen:
 call taster1_gdr
 call taster2_gdr
 call taster3_gdr
 call st20              ; Ansteuerung LCD-Display
 call st30              ; Ansteuerung LCD-Anzeige vorbereiten
 call im_kreis_laufen 
 ret
;-------------------------------------------------------------------------------
;	Led1 toggeln  
;-------------------------------------------------------------------------------
;  
Led1_toggeln:
    lds r17,merker1
	cpi r17,0
	brne end_led
;
    lds r16,sr_oup_portd
	ori r16,Led1
    sts sr_oup_portd,r16
	ldi r17,1
	sts merker1,r17
    ret
;
;
end_led:
    lds r16,sr_oup_portd
	andi r16,(255-Led1)
    sts sr_oup_portd,r16
    ldi r17,0
	sts merker1,r17
    ret
;-------------------------------------------------------------------------------
;	Led2 toggeln  
;-------------------------------------------------------------------------------
;  
Led2_toggeln:
    lds r17,merker2
	cpi r17,0
	brne end_led2
;
    lds r16,sr_oup_portd
	ori r16,Led2
    sts sr_oup_portd,r16
	ldi r17,1
	sts merker2,r17
    ret
;
;
end_led2:
    lds r16,sr_oup_portd
	andi r16,(255-Led2)
    sts sr_oup_portd,r16
    ldi r17,0
	sts merker2,r17
    ret
;  
;-------------------------------------------------------------------------------
;  
;	Alle Sekundenfelder zu null zhlen
;  
;-------------------------------------------------------------------------------
;  
sec_dec:     
    ldsw Z,sr_sec1
    cpiw Z,0
	breq e_sec_dec
;
    siw Z,1
    stsw sr_sec1,Z
e_sec_dec:
    ldsw Z,sr_sec2
    cpiw Z,0
	breq e1_sec_dec
;
    siw Z,1
    stsw sr_sec2,Z
e1_sec_dec:
    ret
;
;-------------------------------------------------------------------------------
;
;	Taster 1 abfragen und Nachlaufdauer setzen
;
;-------------------------------------------------------------------------------
; sr_inp_portd wird am Anfang jedes Zykluses aktualisiert
taster1_gdr:
    lds r16,sr_inp_portd
	andi r16,Taster1
 	breq k_taste1
;
    mm  sr_sec1,k7_ein    ; wenn Taste 1 gedrckt wird die Nachlaufzeit fr K7
;                         ; setzen
k_taste1:
    ret
;
;-------------------------------------------------------------------------------
;
;	Taster 2 abfragen und Nachlaufdauer setzen
;
;-------------------------------------------------------------------------------
; sr_inp_portd wird am Anfang jedes Zykluses aktualisiert
taster2_gdr:
    lds r16,sr_inp_portd
	andi r16,Taster2
 	breq k_taste2
;
    mm  sr_sec2,k8_ein    ; wenn Taste 2 gedrckt wird die Nachlaufzeit fr K8
;                         ; setzen
k_taste2:
    ret
;
;-------------------------------------------------------------------------------
;
;	Taster 3 abfragen und solange wie gedrckt hupen
;
;-------------------------------------------------------------------------------
; sr_inp_portd wird am Anfang jedes Zykluses aktualisiert
taster3_gdr:
    lds r16,sr_inp_portd
	andi r16,Taster3
 	breq k_taste3
;
    call Hupe_toggeln
k_taste3:
    ret


;-------------------------------------------------------------------------------
;	Hupe toggeln
;-------------------------------------------------------------------------------
;  
Hupe_toggeln:
    lds r17,merker3
	cpi r17,0
	brne end_hupe
;
    lds r16,sr_oup_portd
	ori r16,Hupe
    sts sr_oup_portd,r16
    ldi r17,1
	sts merker3,r17
    ret
;
;
end_hupe:
    lds r16,sr_oup_portd
	andi r16,(255-Hupe)
    sts sr_oup_portd,r16
    ldi r17,0
	sts merker3,r17
    ret
;-------------------------------------------------------------------------------
;	Prozessorzeit verschwenden weil er noch nicht viel zu tun hat
;   z.B. 10000 mal im Kreis laufen und trotzdem kommt er noch auf
;   ca. 320 Zyklen pro Sec. siehe Parameter 935 bzw. rechte Zahl
;   in der oberen Zeile
;-------------------------------------------------------------------------------
;  
im_kreis_laufen:
    ldi r16,100
	ldi r17,10
im_kreis:
    nop
    nop
    nop
    dec r16
    brne im_kreis
;
    ldi r16,100
    dec r17
    brne im_kreis
;
    ret
;-------------------------------------------------------------------------------
;
; Unterroutine Funktionsablauf LCD ansteuern
;
;-------------------------------------------------------------------------------

st20:
    ldiw Z,ft20
    ldsw X,fu20c
    cpiw X,(ften20-ft20)/2+1
	brsh est20 ; nicht in den sicheren Tod erlauben
;              
    addw Z,X
    addw Z,X
    ijmp 
;
;
est20:
    ret
;
;
ft20:   jmp ve20            ; F000
        jmp ve20            ; F000
        jmp ve20            ; F000
        jmp ve20            ; F000
        jmp clear           ; F000
        jmp control         ; F000
        jmp enable          ; F000
        jmp display1        ; F000
        jmp disable         ; F000
        jmp clear           ; F000
        jmp ve20            ; F000
        jmp control         ; F000
        jmp enable          ; F000
        jmp display1        ; F000
        jmp disable         ; F000
        jmp clear           ; F000
        jmp ve20            ; F000
        jmp control         ; F000
        jmp enable          ; F000
        jmp display1        ; F000
        jmp disable         ; F000
        jmp clear           ; F000
        jmp ve20            ; F000
        jmp control         ; F000
        jmp enable          ; F000
        jmp display2        ; F000
        jmp disable         ; F000
        jmp clear           ; F000
        jmp ve20            ; F000
        jmp control         ; F000
        jmp enable          ; F000
        jmp display3        ; F000
        jmp disable         ; F000
        jmp clear           ; F000
        jmp ve20            ; F000
        jmp control         ; F000
        jmp enable          ; F000
        jmp display4        ; F000
        jmp disable         ; F000
        jmp clear           ; F000
        jmp ve20            ; F000
        jmp control         ; F000
        jmp enable          ; F000
        jmp display5        ; F000
        jmp disable         ; F000
        jmp clear           ; F000
        jmp ve20            ; F000
ftweit:
        jmp control         ; F000
        jmp enable          ; F000
        jmp cursor_home     ; F000
        jmp disable         ; F000
        jmp control         ; F000
        jmp enable          ; F000
        jmp anfang_z1       ; F000
        jmp disable         ; F000
        jmp daten           ; F000
        jmp enable          ; F000
        jmp zeile1_01       ; F000
        jmp disable         ; F000
        jmp enable          ; F000
        jmp zeile1_02       ; F000
        jmp disable         ; F000
        jmp enable          ; F000
        jmp zeile1_03       ; F000
        jmp disable         ; F000
        jmp enable          ; F000
        jmp zeile1_04       ; F000
        jmp disable         ; F000
        jmp enable          ; F000
        jmp zeile1_05       ; F000
        jmp disable         ; F000
        jmp enable          ; F000
        jmp zeile1_06       ; F000
        jmp disable         ; F000
        jmp enable          ; F000
        jmp zeile1_07       ; F000
        jmp disable         ; F000
        jmp enable          ; F000
        jmp zeile1_08       ; F000
        jmp disable         ; F000
        jmp enable          ; F000
        jmp zeile1_09       ; F000
        jmp disable         ; F000
        jmp enable          ; F000
        jmp zeile1_10       ; F000
        jmp disable         ; F000
        jmp enable          ; F000
        jmp zeile1_11       ; F000
        jmp disable         ; F000
        jmp enable          ; F000
        jmp zeile1_12       ; F000
        jmp disable         ; F000
        jmp enable          ; F000
        jmp zeile1_13       ; F000
        jmp disable         ; F000
        jmp enable          ; F000
        jmp zeile1_14       ; F000
        jmp disable         ; F000
        jmp enable          ; F000
        jmp zeile1_15       ; F000
        jmp disable         ; F000
        jmp enable          ; F000
        jmp zeile1_16       ; F000
        jmp disable         ; F000
        jmp control         ; F000
        jmp enable          ; F000
        jmp anfang_z2       ; F000
        jmp disable         ; F000
        jmp daten           ; F000
        jmp enable          ; F000
        jmp zeile2_01       ; F000
        jmp disable         ; F000
        jmp enable          ; F000
        jmp zeile2_02       ; F000
        jmp disable         ; F000
        jmp enable          ; F000
        jmp zeile2_03       ; F000
        jmp disable         ; F000
        jmp enable          ; F000
        jmp zeile2_04       ; F000
        jmp disable         ; F000
        jmp enable          ; F000
        jmp zeile2_05       ; F000
        jmp disable         ; F000
        jmp enable          ; F000
        jmp zeile2_06       ; F000
        jmp disable         ; F000
        jmp enable          ; F000
        jmp zeile2_07       ; F000
        jmp disable         ; F000
        jmp enable          ; F000
        jmp zeile2_08       ; F000
        jmp disable         ; F000
        jmp enable          ; F000
        jmp zeile2_09       ; F000
        jmp disable         ; F000
        jmp enable          ; F000
        jmp zeile2_10       ; F000
        jmp disable         ; F000
        jmp enable          ; F000
        jmp zeile2_11       ; F000
        jmp disable         ; F000
        jmp enable          ; F000
        jmp zeile2_12       ; F000
        jmp disable         ; F000
        jmp enable          ; F000
        jmp zeile2_13       ; F000
        jmp disable         ; F000
        jmp enable          ; F000
        jmp zeile2_14       ; F000
        jmp disable         ; F000
        jmp enable          ; F000
        jmp zeile2_15       ; F000
        jmp disable         ; F000
        jmp enable          ; F000
        jmp zeile2_16       ; F000
        jmp disable         ; F000
        jmp fuset           ; F017
ften20: jmp ful20           ; F017
;
; Alles einschalten   
;
alles_ein:          
      ldi r16,0x30
      sts sr_oup_porta,r16
      ldi r16,0x07
      sts sr_oup_portc,r16
      jmp inf20
;
; Display anwhlen   
;
displayx:          
      lds r16,sr_hsec
      sts sr_oup_portc,r16
      jmp inf20
;
; Daten clear        
;
clear:            
      lds r16,sr_oup_portc
      andi r16,(255-7)
      sts sr_oup_portc,r16
      ldi r16,0
	  sts sr_oup_porta,r16
      jmp inf20
;
; Control schreiben        
;
control:            
      lds r16,sr_oup_portc
      andi r16,(255-1)
      sts sr_oup_portc,r16
      jmp inf20
;
; Daten schreiben        
;
daten:            
      lds r16,sr_oup_portc
      ori r16,1
      sts sr_oup_portc,r16
      jmp inf20
;
; Daten schreiben        
;
lesen:            
      lds r16,sr_oup_portc
      ori r16,2
      sts sr_oup_portc,r16
      jmp inf20
;
; Anfang Zeile 1 setzen                 
;
anfang_z1:         
      ldi r16,0x80
      sts sr_oup_porta,r16
      jmp inf20
;
; Anfang Zeile 2 setzen                 
;
anfang_z2:         
      ldi r16,0xc0
      sts sr_oup_porta,r16
      jmp inf20
;
; Display anwhlen 2.Zeilen 5*10Dots
;
display1:          
      ldi r16,0x3f
      sts sr_oup_porta,r16
      jmp inf20
;
; Display mit 5*7 Dots   
;
display2:          
      ldi r16,0x0f
      sts sr_oup_porta,r16
      jmp inf20
;
; Cursor blinking  
;
display3:          
      ldi  r16,0x0d
	  sts sr_oup_porta,r16
      jmp inf20
;
; Display clear 
;
display4:         
      ldi  r16,0x01
	  sts sr_oup_porta,r16
      jmp inf20
;
; Cursor schiften
;
display5:          
      ldi  r16,0x06
	  sts sr_oup_porta,r16
      jmp inf20
;
; Cursor auf 1 Position
;
cursor_home:
      ldi  r16,0x02
	  sts sr_oup_porta,r16
      jmp inf20
;
; Cursor auf 1 Position
;
cursor_home_:
      ldi  r16,0x02
	  sts sr_oup_porta,r16
      jmp inf20
;
; Position 1    
;
pos1:              
      ldi  r16,0x00
	  sts sr_oup_porta,r16
      jmp inf20
;
; Daten Ausgabe        
;
daten_ausgabe1:           
      ldi r16,0x30
      sts sr_oup_porta,r16
      jmp inf20
;
; Daten Ausgabe        
;
daten_ausgabe2:           
      ldi  r16,0x31
      sts sr_oup_porta,r16
      jmp inf20
;
; Daten Ausgabe        
;
daten_ausgabe3:           
      ldi  r16,0x32
      sts sr_oup_porta,r16
      jmp inf20
;
; Daten Ausgabe        
;
daten_ausgabe5:           
      lds  r16,sr_sec
      sts sr_oup_porta,r16
      jmp inf20
;
; Daten Ausgabe        
;
zeile1_01:               
      lds  r16,stelle1_01
      sts sr_oup_porta,r16
      jmp inf20
;
; Daten Ausgabe        
;
zeile1_02:               
      lds  r16,stelle1_02
      sts sr_oup_porta,r16
      jmp inf20
;
; Daten Ausgabe        
;
zeile1_03:               
      lds  r16,stelle1_03
      sts sr_oup_porta,r16
      jmp inf20
;
; Daten Ausgabe        
;
zeile1_04:               
      lds  r16,stelle1_04
      sts sr_oup_porta,r16
      jmp inf20
;
; Daten Ausgabe        
;
zeile1_05:               
      lds  r16,stelle1_05
      sts sr_oup_porta,r16
      jmp inf20
;
; Daten Ausgabe        
;
zeile1_06:               
      lds  r16,stelle1_06
      sts sr_oup_porta,r16
      jmp inf20
;
; Daten Ausgabe        
;
zeile1_07:               
      lds  r16,stelle1_07
      sts sr_oup_porta,r16
      jmp inf20
;
; Daten Ausgabe        
;
zeile1_08:               
      lds  r16,stelle1_08
      sts sr_oup_porta,r16
      jmp inf20
;
; Daten Ausgabe        
;
zeile1_09:               
      lds  r16,stelle1_09
      sts sr_oup_porta,r16
      jmp inf20
;
; Daten Ausgabe        
;
zeile1_10:               
      lds  r16,stelle1_10
      sts sr_oup_porta,r16
      jmp inf20
;
; Daten Ausgabe        
;
zeile1_11:               
      lds  r16,stelle1_11
      sts sr_oup_porta,r16
      jmp inf20
;
; Daten Ausgabe        
;
zeile1_12:               
      lds  r16,stelle1_12
      sts sr_oup_porta,r16
      jmp inf20
;
; Daten Ausgabe        
;
zeile1_13:               
      lds  r16,stelle1_13
      sts sr_oup_porta,r16
      jmp inf20
;
; Daten Ausgabe        
;
zeile1_14:               
      lds  r16,stelle1_14
      sts sr_oup_porta,r16
      jmp inf20
;
; Daten Ausgabe        
;
zeile1_15:               
      lds  r16,stelle1_15
      sts sr_oup_porta,r16
      jmp inf20
;
; Daten Ausgabe        
;
zeile1_16:               
      lds  r16,stelle1_16
      sts sr_oup_porta,r16
      jmp inf20
;
; Daten Ausgabe        
;
zeile2_01:               
      lds  r16,stelle2_01
      sts sr_oup_porta,r16
      jmp inf20
;
; Daten Ausgabe        
;
zeile2_02:               
      lds  r16,stelle2_02
      sts sr_oup_porta,r16
      jmp inf20
;
; Daten Ausgabe        
;
zeile2_03:               
      lds  r16,stelle2_03
      sts sr_oup_porta,r16
      jmp inf20
;
; Daten Ausgabe        
;
zeile2_04:               
      lds  r16,stelle2_04
      sts sr_oup_porta,r16
      jmp inf20
;
; Daten Ausgabe        
;
zeile2_05:               
      lds  r16,stelle2_05
      sts sr_oup_porta,r16
      jmp inf20
;
; Daten Ausgabe        
;
zeile2_06:               
      lds  r16,stelle2_06
      sts sr_oup_porta,r16
      jmp inf20
;
; Daten Ausgabe        
;
zeile2_07:               
      lds  r16,stelle2_07
      sts sr_oup_porta,r16
      jmp inf20
;
; Daten Ausgabe        
;
zeile2_08:               
      lds  r16,stelle2_08
      sts sr_oup_porta,r16
      jmp inf20
;
; Daten Ausgabe        
;
zeile2_09:               
      lds  r16,stelle2_09
      sts sr_oup_porta,r16
      jmp inf20
;
; Daten Ausgabe        
;
zeile2_10:               
      lds  r16,stelle2_10
      sts sr_oup_porta,r16
      jmp inf20
;
; Daten Ausgabe        
;
zeile2_11:               
      lds  r16,stelle2_11
      sts sr_oup_porta,r16
      jmp inf20
;
; Daten Ausgabe        
;
zeile2_12:               
      lds  r16,stelle2_12
      sts sr_oup_porta,r16
      jmp inf20
;
; Daten Ausgabe        
;
zeile2_13:               
      lds  r16,stelle2_13
      sts sr_oup_porta,r16
      jmp inf20
;
; Daten Ausgabe        
;
zeile2_14:               
      lds  r16,stelle2_14
      sts sr_oup_porta,r16
      jmp inf20
;
; Daten Ausgabe        
;
zeile2_15:               
      lds  r16,stelle2_15
      sts sr_oup_porta,r16
      jmp inf20
;
; Daten Ausgabe        
;
zeile2_16:               
      lds  r16,stelle2_16
      sts sr_oup_porta,r16
      jmp inf20
;
; Daten Ausgabe        
;
daten_ausgabe4:           
      ldi  r16,0x33
      sts sr_oup_porta,r16
      jmp inf20
;
; Daten enable        
;
enable:            
      lds r16,sr_oup_portc
      ori r16,4
      sts sr_oup_portc,r16
      jmp inf20
;
; Daten enable        
;
disable:            
      lds r16,sr_oup_portc
      andi r16,(255-4)
      sts sr_oup_portc,r16
      jmp inf20
;
; Verzgerung         
;
ve20:              
      incm sr_v20f          
      ldsw X,sr_v20f
      cpiw X,200  
      brlo eve20
;
	  jmp inf20
;
;
eve20:
      ret
;
;
; Funktionsschritt erhhen
;
;
inf20:
    incm fu20c
    smemw sr_v20f,0
	ret
;
;
; Funktionsschritt setzen 
;
;
fuset:
    smemw fu20c,(ftweit-ft20)/2
    smemw sr_v20f,0
	ret
;
;
; Funktionsschritt lschen
;
;
ful20:
    smemw fu20c,0
    smemw sr_v20f,0
	ret
 
;-------------------------------------------------------------------------------
;
; Unterroutine Funktionsablauf Zahlen zur LCD Anzeige vorbereiten 
;
;-------------------------------------------------------------------------------

st30:
    ldiw Z,ft30
    ldsw X,fu30c
    cpiw X,(ften30-ft30)/2+1
	brsh est30 ; nicht in den sicheren Tod erlauben
;              
    addw Z,X
    addw Z,X
    ijmp 
;
;
est30:
    ret
;
;
ft30:   jmp ve30            ; F000
        jmp con_std         ; F000
        jmp mov_std         ; F000
        jmp con_min         ; F000
        jmp mov_min         ; F000
        jmp con_sec         ; F000
        jmp mov_sec         ; F000
ften30: jmp ful30           ; F017
;
;
mov_std:
    lds r16,bcd2      
    sts stelle2_09,r16
    lds r16,bcd1      
    sts stelle2_10,r16
    jmp bin2bcd
;
;
mov_min:
    ldi r16,':'       
    sts stelle2_11,r16
    lds r16,bcd2      
    sts stelle2_12,r16
    lds r16,bcd1      
    sts stelle2_13,r16
    jmp bin2bcd
;
;
mov_sec:
    ldi r16,':'       
    sts stelle2_14,r16
    lds r16,bcd2      
    sts stelle2_15,r16
    lds r16,bcd1      
    sts stelle2_16,r16
    jmp bin2bcd
;
;
con_std:
    lds fbinL,sr_std
    lds fbinH,sr_std+1   
    jmp bin2bcd
;
;
con_min:
    lds fbinL,sr_min
    lds fbinH,sr_min+1   
    jmp bin2bcd
;
;
con_sec:
    lds fbinL,sr_sec
    lds fbinH,sr_sec+1   
bin2bcd:
	rcall	bin2BCD16	;result: tBCD2:tBCD1:tBCD0
    mov r16,tBCD0
    andi r16,0x0F
    ldi r20,0x30
    add r16,r20
    sts bcd1,r16
    mov r16,tBCD0
    ror r16
    ror r16
    ror r16
    ror r16
    andi r16,0x0F
    add r16,r20
    sts bcd2,r16
    mov r16,tBCD1
    andi r16,0x0F
    add r16,r20
    sts bcd3,r16
    mov r16,tBCD1
    ror r16
    ror r16
    ror r16
    ror r16
    andi r16,0x0F
    add r16,r20
    sts bcd4,r16
    add tbcd2,r20
    sts bcd5,tbcd2
	jmp inf30
;
; Verzgerung         
;
ve30:              
      incm sr_v30f          
      ldsw X,sr_v30f
      cpiw X,200  
      brlo eve30
;
	  jmp inf30
;
;
eve30:
      ret
;
;
; Funktionsschritt erhhen
;
;
inf30:
    incm fu30c
    smemw sr_v30f,0
	ret
;
;
; Funktionsschritt lschen
;
;
ful30:
    smemw fu30c,0
    smemw sr_v30f,0
	ret

;***************************************************************************
;*
;* "bin2BCD16" - 16-bit Binary to BCD conversion
;*
;* This subroutine converts a 16-bit number (fbinH:fbinL) to a 5-digit 
;* packed BCD number represented by 3 bytes (tBCD2:tBCD1:tBCD0).
;* MSD of the 5-digit number is placed in the lowermost nibble of tBCD2.
;*  
;* Number of words	:25
;* Number of cycles	:751/768 (Min/Max)
;* Low registers used	:3 (tBCD0,tBCD1,tBCD2) 
;* High registers used  :4(fbinL,fbinH,cnt16a,tmp16a)	
;* Pointers used	:Z
;*
;***************************************************************************

;***** Subroutine Register Variables

.equ	AtBCD0	=13		;address of tBCD0
.equ	AtBCD2	=15		;address of tBCD1

.def	tBCD0	=r13		;BCD value digits 1 and 0
.def	tBCD1	=r14		;BCD value digits 3 and 2
.def	tBCD2	=r15		;BCD value digit 4
.def	fbinL	=r16		;binary value Low byte
.def	fbinH	=r17		;binary value High byte
.def	cnt16a	=r18		;loop counter
.def	tmp16a	=r19		;temporary value

;***** Code

bin2BCD16:
	ldi	cnt16a,16	;Init loop counter	
	clr	tBCD2		;clear result (3 bytes)
	clr	tBCD1		
	clr	tBCD0		
	clr	ZH		;clear ZH (not needed for AT90Sxx0x)
bBCDx_1:lsl	fbinL		;shift input value
	rol	fbinH		;through all bytes
	rol	tBCD0		;
	rol	tBCD1
	rol	tBCD2
	dec	cnt16a		;decrement loop counter
	brne	bBCDx_2		;if counter not zero
	ret			;   return

bBCDx_2:ldi	r30,AtBCD2+1	;Z points to result MSB + 1
bBCDx_3:
	ld	tmp16a,-Z	;get (Z) with pre-decrement
;----------------------------------------------------------------
;For AT90Sxx0x, substitute the above line with:
;
;	dec	ZL
;	ld	tmp16a,Z
;
;----------------------------------------------------------------
	subi	tmp16a,-$03	;add 0x03
	sbrc	tmp16a,3	;if bit 3 not clear
	st	Z,tmp16a	;	store back
	ld	tmp16a,Z	;get (Z)
	subi	tmp16a,-$30	;add 0x30
	sbrc	tmp16a,7	;if bit 7 not clear
	st	Z,tmp16a	;	store back
	cpi	ZL,AtBCD0	;done all three?
	brne	bBCDx_3		;loop again if not
	rjmp	bBCDx_1		

.EXIT                           ;Ende des Quelltextes
