;-------------------------------------------------------------------------------
;       Einbinden der controllerspezifischen Definitionsdatei
;-------------------------------------------------------------------------------
.NOLIST                         ;List-Output ausschalten
.INCLUDE "m32def.inc"           ;AVR-Definitionsdatei einbinden
.INCLUDE "reszif.asm"           ;Resevierung Ziffernanzeige
.INCLUDE "MeineMacros.inc"      ;Meine Macros
.INCLUDE "AVRMacros.inc"        ;AVR Macros mit einer nderung von mir 
;                               ;addi funktionierte nicht richtig
.LIST                           ;List-Output wieder einschalten

;*******************************************************************************
; alle Parameter von 000 - 899 stehen zur freien Verfgung
;*******************************************************************************
.equ uhrzeit     = var001      ; 001 Uhrzeit in Sunden * 100 + Minuten Format HHMM       
.equ k1_ein      = var011      ; 011 Einschaltzeit Kanal 1 HHMM
.equ k2_ein      = var012      ; 012 Einschaltzeit Kanal 2 HHMM
.equ k3_ein      = var013      ; 013 Einschaltzeit Kanal 3 HHMM
.equ k4_ein      = var014      ; 014 Einschaltzeit Kanal 4 HHMM
.equ k5_ein      = var015      ; 015 Einschaltzeit Kanal 5 HHMM
.equ k6_ein      = var016      ; 016 Einschaltzeit Kanal 6 HHMM
.equ k7_ein      = var017      ; 017 Nachlaufzeit in Sekunden Kanal 7 wenn Taster 1 gedrckt wurde
.equ k8_ein      = var018      ; 018 Nachlaufzeit in Sekunden Kanal 8 wenn Taster 2 gedrckt wurde

.equ k1_aus      = var021      ; 021 Ausschaltzeit Kanal 1 HHMM
.equ k2_aus      = var022      ; 022 Ausschaltzeit Kanal 2 HHMM
.equ k3_aus      = var023      ; 023 Ausschaltzeit Kanal 3 HHMM
.equ k4_aus      = var024      ; 024 Ausschaltzeit Kanal 4 HHMM
.equ k5_aus      = var025      ; 025 Ausschaltzeit Kanal 5 HHMM
.equ k6_aus      = var026      ; 026 Ausschaltzeit Kanal 6 HHMM


.equ fu10c       = var070      ; 070 Funktionsschritt Schaltuhr              
;
.equ merker1     = var801      ; 801 Merker um Led 1 zu schalten 1 Byte reicht
.equ merker2     = var801+1    ; 801+1 Merker um Led 2 zu schalten 1 Byte reicht
.equ merker3     = var802      ; 802 Merker um Hupe zu schalten 1 Byte reicht

.equ sr_sec1     = var803      ; 803 Sekundenzaehler 1 wird zu null gezhlt
.equ sr_sec2     = var804      ; 804 Sekundenzaehler 2 wird zu null gezhlt


.equ Led1 = 0x20               ; Bit Led 1
.equ Led2 = 0x40               ; Bit Led 2
.equ Hupe = 0x80               ; Bit Hupe
.equ Taster1 = 0x04            ; Bit Taster 1
.equ Taster2 = 0x08            ; Bit Taster 2
.equ Taster3 = 0x10            ; Bit Taster 3


;*******************************************************************************
; alle Parameter von 900 - 999 sind vom System belegt
;*******************************************************************************
;
; sr_inp_portx wird am Anfang eines jedes Zyklus vom Eingangsport eingelesen
; und nur hier
.equ sr_inp_porta = var901   ; 901 Eingangsbyte Port A
.equ sr_inp_portb = var902   ; 902 Eingangsbyte Port B
.equ sr_inp_portc = var903   ; 903 Eingangsbyte Port C
.equ sr_inp_portd = var904   ; 904 Eingangsbyte Port D
;
; sr_oup_portx wird am Ende jedes Zyklus an das Ausgangsport weitergegeben
; und nur hier
.equ sr_oup_porta = var905   ; 905 Ausgangsbyte Port A
.equ sr_oup_portb = var906   ; 905 Ausgangsbyte Port B
.equ sr_oup_portc = var907   ; 905 Ausgangsbyte Port C
.equ sr_oup_portd = var908   ; 908 Eingangsbyte Port D

.equ sr_sec       = var912   ; 912 Sekunde
.equ sr_min       = var913   ; 913 Minute 
.equ sr_std       = var914   ; 914 Stunde
.equ sr_tag       = var915   ; 915 Tag    
.equ sr_mon       = var916   ; 916 Monat  
.equ sr_jahr      = var915   ; 917 Jahr
;
;                            ; 921 SRAM-Daten von 000-499 
;                            ;     und Datum und Uhrzeit
;                            ;     1 = im EEPROM ablegen
;                            ;     2 = aus EEPROM lesen
;                            ;  1001 = alle Werte von 000-499 auf 0 setzen
;                            ;  1002 = alle Werte von 500-899 auf 0 setzen
;
;                            ; 935 Programmzyklen pro Sekunde
;
;*******************************************************************************
	
	
;===============================================================================
.CSEG                                                                            
.ORG    0x1000                  
user_init:    
 nop
jmp initialisieren
;===============================================================================
.CSEG                                                                            
.ORG    0x1004                  
jede_hsekunde:
 nop
jmp alle_10ms
;===============================================================================
.CSEG                                                                            
.ORG    0x1008                  
jede_zsekunde:
 nop
jmp alle_100ms
;===============================================================================
.ORG    0x100c                  
jede_sekunde:
 nop
jmp alle_1000ms
;===============================================================================
.ORG    0x1010                  
jeder_zyklus:
 nop
jmp alle_zyklen
;===============================================================================
.ORG    0x1020                  
; 1.Zeile Text auf dem Bildschirm
; Anlagenname als Text
Anlagenname1:
   .DB 27,"[1;15H",27,"#3Schaltuhr@"
.ORG    0x1060                  
; 2.Zeile Text auf dem Bildschirm
; Anlagenname als Text
Anlagenname2:
   .DB 27,"[2;15H",27,"#4Schaltuhr@"
;
.ORG    0x1100                  
;
;*******************************************************************************
; was hier steht wird nach jedem Neustart ausgefhrt
;*******************************************************************************
;
initialisieren:
;
; hier knnen die Ports A-C neu initialisiert werden.
; Bitte Port D nicht ndern.
; z.B.
         ldi r16, 0xff
         out DDRA, r16     ; Alle Pins am Port A durch Ausgabe von 0xFF ins
                           ; Richtungsregister DDRA als Ausgang konfigurieren
         ldi r16, 0x00
         out DDRB, r16     ; Alle Pins am Port B durch Ausgabe von 0x00 ins
                           ; Richtungsregister DDRB als Eingang konfigurieren
         ldi r16, 0x00
         out DDRC, r16     ; Alle Pins am Port C durch Ausgabe von 0x00 ins
                           ; Richtungsregister DDRC als Eingang konfigurieren
         smemw fu10c,0     ; Funktionsschritt auf 0 setzen
 ret
;
;*******************************************************************************
; was hier steht wird alle 10ms ausgefhrt
;*******************************************************************************
;
alle_10ms:
 ret
;
;*******************************************************************************
; was hier steht wird alle 100ms ausgefhrt
;*******************************************************************************
;
alle_100ms:
 call Led1_toggeln
 ret
;
;*******************************************************************************
; was hier steht wird alle 1000ms ausgefhrt
;*******************************************************************************
;
alle_1000ms:
 call Led2_toggeln
 call sec_dec
 ret
;
;*******************************************************************************
; was hier steht was so den Rest der Zeit ausgefhrt werden soll
; das heit alle Interrupts sind abgearbeitet
;*******************************************************************************
;
alle_zyklen:
 call taster1_gdr
 call taster2_gdr
 call taster3_gdr
 call st10              ; Schaltuhr 8 Kanle
 call im_kreis_laufen 
 ret
;-------------------------------------------------------------------------------
;	Led1 toggeln  
;-------------------------------------------------------------------------------
;  
Led1_toggeln:
    lds r17,merker1
	cpi r17,0
	brne end_led
;
    lds r16,sr_oup_portd
	ori r16,Led1
    sts sr_oup_portd,r16
	ldi r17,1
	sts merker1,r17
    ret
;
;
end_led:
    lds r16,sr_oup_portd
	andi r16,(255-Led1)
    sts sr_oup_portd,r16
    ldi r17,0
	sts merker1,r17
    ret
;-------------------------------------------------------------------------------
;	Led2 toggeln  
;-------------------------------------------------------------------------------
;  
Led2_toggeln:
    lds r17,merker2
	cpi r17,0
	brne end_led2
;
    lds r16,sr_oup_portd
	ori r16,Led2
    sts sr_oup_portd,r16
	ldi r17,1
	sts merker2,r17
    ret
;
;
end_led2:
    lds r16,sr_oup_portd
	andi r16,(255-Led2)
    sts sr_oup_portd,r16
    ldi r17,0
	sts merker2,r17
    ret
;  
;-------------------------------------------------------------------------------
;  
;	Alle Sekundenfelder zu null zhlen
;  
;-------------------------------------------------------------------------------
;  
sec_dec:     
    ldsw Z,sr_sec1
    cpiw Z,0
	breq e_sec_dec
;
    siw Z,1
    stsw sr_sec1,Z
e_sec_dec:
    ldsw Z,sr_sec2
    cpiw Z,0
	breq e1_sec_dec
;
    siw Z,1
    stsw sr_sec2,Z
e1_sec_dec:
    ret
;
;-------------------------------------------------------------------------------
;
;	Taster 1 abfragen und Nachlaufdauer setzen
;
;-------------------------------------------------------------------------------
; sr_inp_portd wird am Anfang jedes Zykluses aktualisiert
taster1_gdr:
    lds r16,sr_inp_portd
	andi r16,Taster1
 	breq k_taste1
;
    mm  sr_sec1,k7_ein    ; wenn Taste 1 gedrckt wird die Nachlaufzeit fr K7
;                         ; setzen
k_taste1:
    ret
;
;-------------------------------------------------------------------------------
;
;	Taster 2 abfragen und Nachlaufdauer setzen
;
;-------------------------------------------------------------------------------
; sr_inp_portd wird am Anfang jedes Zykluses aktualisiert
taster2_gdr:
    lds r16,sr_inp_portd
	andi r16,Taster2
 	breq k_taste2
;
    mm  sr_sec2,k8_ein    ; wenn Taste 2 gedrckt wird die Nachlaufzeit fr K8
;                         ; setzen
k_taste2:
    ret
;
;-------------------------------------------------------------------------------
;
;	Taster 3 abfragen und solange wie gedrckt hupen
;
;-------------------------------------------------------------------------------
; sr_inp_portd wird am Anfang jedes Zykluses aktualisiert
taster3_gdr:
    lds r16,sr_inp_portd
	andi r16,Taster3
 	breq k_taste3
;
    call Hupe_toggeln
k_taste3:
    ret


;-------------------------------------------------------------------------------
;	Hupe toggeln
;-------------------------------------------------------------------------------
;  
Hupe_toggeln:
    lds r17,merker3
	cpi r17,0
	brne end_hupe
;
    lds r16,sr_oup_portd
	ori r16,Hupe
    sts sr_oup_portd,r16
    ldi r17,1
	sts merker3,r17
    ret
;
;
end_hupe:
    lds r16,sr_oup_portd
	andi r16,(255-Hupe)
    sts sr_oup_portd,r16
    ldi r17,0
	sts merker3,r17
    ret
;-------------------------------------------------------------------------------
;	Prozessorzeit verschwenden weil er noch nicht viel zu tun hat
;   z.B. 1000 mal im Kreis laufen und trotzdem kommt er noch auf
;   ca. 2105 Zyklen pro Sec. siehe Parameter 935 bzw. rechte Zahl
;   in der oberen Zeile
;-------------------------------------------------------------------------------
;  
im_kreis_laufen:
    ldi r16,100
	ldi r17,10
im_kreis:
    nop
    nop
    nop
    dec r16
    brne im_kreis
;
    ldi r16,100
    dec r17
    brne im_kreis
;
    ret
;-------------------------------------------------------------------------------
;
; Unterroutine Funktionsablauf Schaltuhr 8 Kanle
;
;-------------------------------------------------------------------------------

st10:
    ldiw Z,ft10
    ldsw X,fu10c
    cpiw X,(ften10-ft10)/2+1
	brsh est10 ; nicht in den sicheren Tod erlauben
;              
    addw Z,X
    addw Z,X
    ijmp 
;
;
est10:
    ret
;
;
ft10:   jmp bilde_uhrzeit   ; F000
        jmp kanal1_ein      ; F001
        jmp kanal2_ein      ; F002
        jmp kanal3_ein      ; F003
        jmp kanal4_ein      ; F004
        jmp kanal5_ein      ; F005
        jmp kanal6_ein      ; F006
        jmp kanal7_ein      ; F007
        jmp kanal8_ein      ; F008
        jmp kanal1_aus      ; F009
        jmp kanal2_aus      ; F010
        jmp kanal3_aus      ; F011
        jmp kanal4_aus      ; F012
        jmp kanal5_aus      ; F013
        jmp kanal6_aus      ; F014
        jmp kanal7_aus      ; F015
        jmp kanal8_aus      ; F016
ften10: jmp ful10           ; F017
;
; Schaltzeit bilden im Format SSMM
; dann kann die Ein- und Ausschaltzeit
; im gleichen Format einfacher eingestellt
; werden. z.B. 2230 steht fr 22:30
;
bilde_uhrzeit:
      ldsw X,sr_std
      ldiw Y,0
      addw X,X ;* 2
      addw X,X ;* 4
      addw Y,X ;+ 4
      addw X,X ;* 8
      addw X,X ;* 16
      addw X,X ;* 32
      addw Y,X ;4 + 32
      addw X,X ;* 64
      addw X,Y ;36 + 64 = 100
      ldsw Y,sr_min 
      addw X,Y
      stsw uhrzeit,X
      jmp inf10
;
; Kanal 1 einschalten
;
kanal1_ein:
      ldsw X,uhrzeit
      ldsw Y,k1_ein 
      subw X,Y
      lbrne inf10
;
      lds r16,sr_oup_porta
      ori r16,1
      sts sr_oup_porta,r16
      jmp inf10
;
; Kanal 2 einschalten
;
kanal2_ein:
      ldsw X,uhrzeit
      ldsw Y,k2_ein 
      subw X,Y
      lbrne inf10
;
      lds r16,sr_oup_porta
      ori r16,2
      sts sr_oup_porta,r16
      jmp inf10
;
; Kanal 3 einschalten
;
kanal3_ein:
      ldsw X,uhrzeit
      ldsw Y,k3_ein 
      subw X,Y
      lbrne inf10
;
      lds r16,sr_oup_porta
      ori r16,4
      sts sr_oup_porta,r16
      jmp inf10
;
; Kanal 4 einschalten
;
kanal4_ein:
      ldsw X,uhrzeit
      ldsw Y,k4_ein 
      subw X,Y
      lbrne inf10
;
      lds r16,sr_oup_porta
      ori r16,8
      sts sr_oup_porta,r16
      jmp inf10
;
; Kanal 5 einschalten
;
kanal5_ein:
      ldsw X,uhrzeit
      ldsw Y,k5_ein 
      subw X,Y
      lbrne inf10
;
      lds r16,sr_oup_porta
      ori r16,16
      sts sr_oup_porta,r16
      jmp inf10
;
; Kanal 6 einschalten
;
kanal6_ein:
      ldsw X,uhrzeit
      ldsw Y,k6_ein 
      subw X,Y
      lbrne inf10
;
      lds r16,sr_oup_porta
      ori r16,32
      sts sr_oup_porta,r16
      jmp inf10
;
; Kanal 7 einschalten
;
kanal7_ein:
      ldsw X,sr_sec1
      cpiw X,0
      lbreq inf10
;
      lds r16,sr_oup_porta
      ori r16,64
      sts sr_oup_porta,r16
      jmp inf10
;
; Kanal 8 einschalten
;
kanal8_ein:
      ldsw X,sr_sec2
      cpiw X,0
      lbreq inf10
;
      lds r16,sr_oup_porta
      ori r16,128
      sts sr_oup_porta,r16
      jmp inf10
;
; Kanal 1 ausschalten
;
kanal1_aus:
      ldsw X,uhrzeit
      ldsw Y,k1_aus 
      subw X,Y
      lbrne inf10
;
      lds r16,sr_oup_porta
      andi r16,(255-1)
      sts sr_oup_porta,r16
      jmp inf10
;
; Kanal 2 ausschalten
;
kanal2_aus:
      ldsw X,uhrzeit
      ldsw Y,k2_aus 
      subw X,Y
      lbrne inf10
;
      lds r16,sr_oup_porta
      andi r16,(255-2)
      sts sr_oup_porta,r16
      jmp inf10
;
; Kanal 3 ausschalten
;
kanal3_aus:
      ldsw X,uhrzeit
      ldsw Y,k3_aus 
      subw X,Y
      lbrne inf10
;
      lds r16,sr_oup_porta
      andi r16,(255-4)
      sts sr_oup_porta,r16
      jmp inf10
;
; Kanal 4 ausschalten
;
kanal4_aus:
      ldsw X,uhrzeit
      ldsw Y,k4_aus 
      subw X,Y
      lbrne inf10
;
      lds r16,sr_oup_porta
      andi r16,(255-8)
      sts sr_oup_porta,r16
      jmp inf10
;
; Kanal 5 ausschalten
;
kanal5_aus:
      ldsw X,uhrzeit
      ldsw Y,k5_aus 
      subw X,Y
      lbrne inf10
;
      lds r16,sr_oup_porta
      andi r16,(255-16)
      sts sr_oup_porta,r16
      jmp inf10
;
; Kanal 6 ausschalten
;
kanal6_aus:
      ldsw X,uhrzeit
      ldsw Y,k6_aus 
      subw X,Y
      lbrne inf10
;
      lds r16,sr_oup_porta
      andi r16,(255-32)
      sts sr_oup_porta,r16
      jmp inf10
;
; Kanal 7 ausschalten
;
kanal7_aus:
      ldsw X,sr_sec1
      cpiw X,0
      lbrne inf10
;
      lds r16,sr_oup_porta
      andi r16,(255-64)
      sts sr_oup_porta,r16
      jmp inf10
;
; Kanal 8 ausschalten
;
kanal8_aus:
      ldsw X,sr_sec2
      cpiw X,0
      lbrne inf10
;
      lds r16,sr_oup_porta
      andi r16,(255-128)
      sts sr_oup_porta,r16
      jmp inf10
;
;
; Funktionsschritt erhhen
;
;
inf10:
    incm fu10c
	ret
;
;
; Funktionsschritt lschen
;
;
ful10:
    smemw fu10c,0
	ret
 

.EXIT                           ;Ende des Quelltextes
